# RCIMkitDemo
iOS App of RCIMkitDemo powered by RongCloud. 基于融云通讯的即时通讯（IM)  App内置国际化语言切换以及系统默认Demo。

RCIMKitDemo 切换 App内国际化语言 核心类为 Utils/LanguageTool 中的两个文件  NSBundle+RCUtils.m，RCLanguageConfig.m
原理 是：
  NSBundle+RCUtils：通过Runtime 动态 类的 + ( void)load  更改 [NSBundle mainBundle] 的对象指针，使其指向 NSBundle的子类
  RCBundle 重写- (NSString *)localizedStringForKey:(NSString *)key value:(NSString *)value table:(NSString *)tableName， 方法内部通过+ (NSBundle *)rc_mainBundle 方法来回去App支持的多语言文件。
  
  RCLanguageConfig: 通过NSUserDefaults  来保存用户设置的 语言，默认为 nil，即系统默认语言
   
   用户选择设置完语言后，需要重置 App的 [UIApplication sharedApplication].delegate.window.rootViewController  来实现App内的
   语言切换功能。
  
  

                        
                    
    RCLanguageSettingController 中设置 国际化代码
    - (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath
    {
       ..... 
        if (indexPath.row == 0) {
        [RCLanguageConfig setLanguage:nil];
        } else if (indexPath.row == 1) {
        [RCLanguageConfig setLanguage:RCChineseLanuage];
        } else {
        [RCLanguageConfig setLanguage:RCEnglishLanuage];
        }
        //清空当前应用栈Controller以及Views，重置Appdelegate.rootController
        //[UIApplication sharedApplication].delegate.window.rootViewController = 
        [[AppDelegate appDelegate] toMainTabAtIndex:1];
    }

               
             
