//
//  AppDelegate.m
//  RCIMKitDemo
//
//  Created by zhiheng on 2018/7/6.
//  Copyright © 2018年 com.wc. All rights reserved.
//

#import "AppDelegate.h"

#import "RCDNavigationViewController.h"

#import "RCTabBarController.h"

#import <RongIMKit/RongIMKit.h>


@interface AppDelegate ()

@end

@implementation AppDelegate

#define RONGCLOUD_IM_APPKEY @"n19jmcy59f1q9" // online key

+ (AppDelegate *)appDelegate
{
    return (AppDelegate*)[UIApplication sharedApplication].delegate;
}
- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions {
 
    //配置 RCIM_AppKey
    [[RCIM sharedRCIM] initWithAppKey:RONGCLOUD_IM_APPKEY];

    //登录融云服务器
    [[RCIM sharedRCIM] connectWithToken:@"g/JrRSaC8wOhHJ3HKpz/EaE4ovwvabHEXU8xDrUJSvGZFOKGf4/ln7MhsE6s6/K6K3Hs6x9pdBAgmI8Q95wKAbbV2v6R1xUE"
                                success:^(NSString *userId) {
                                     [self sendTestMessage:userId];
                                     [self toMainTabAtIndex:0];
                                     //设置登录用户的昵称，这里只为测试使用
                                     RCUserInfo *user = [[RCUserInfo alloc] initWithUserId:userId name:@"zhz123" portrait:@""];
                                     [[RCIM sharedRCIM] refreshUserInfoCache:user withUserId:userId];
                                     [RCIM sharedRCIM].currentUserInfo = user;

                                } error:^(RCConnectErrorCode status) {
                                    
                                }tokenIncorrect:^{
                                }];

        return YES;
}
//测试发送一条会话消息，方便查看
- (void)sendTestMessage:(NSString *)targetId
{
//    RCTextMessage *announcementMsg = [RCTextMessage messageWithContent:@"你好你啊好"];
    RCImageMessage *testImageMsg = [RCImageMessage messageWithImage:[UIImage imageNamed:@"tst"]];
  
    [[RCIM sharedRCIM] sendMessage:ConversationType_PRIVATE
                          targetId:targetId
                           content:testImageMsg
                       pushContent:nil
                          pushData:nil
                           success:^(long messageId) {
                           }
                             error:^(RCErrorCode nErrorCode, long messageId) {
                             }];
    
}

- (void)applicationWillResignActive:(UIApplication *)application {

}


- (void)applicationWillTerminate:(UIApplication *)application {

}

#pragma mark -- 登陆成功
- (void)toMainTabAtIndex:(NSInteger)index
{
    dispatch_async(dispatch_get_main_queue(), ^{
        RCTabBarController *tabBarController =[[RCTabBarController alloc] init];
        tabBarController.selectedIndex = index;
        self.window.rootViewController = [[RCDNavigationViewController alloc] initWithRootViewController:tabBarController];

    });
  
}

@end
