//
//  RCTabBarController.m
//  RCIMKitDemo
//
//  Created by zhiheng on 2018/7/10.
//  Copyright © 2018年 com.wc. All rights reserved.
//

#import "RCTabBarController.h"
#import "RCConversationController.h"
#import "RCMineController.h"


@interface RCTabBarController ()

@end

@implementation RCTabBarController

- (void)viewDidLoad {
    [super viewDidLoad];
    
    [self initControllers];
    
}
- (void)viewWillAppear:(BOOL)animated {
    [super viewWillAppear:animated];
//    [self.viewControllers
//     enumerateObjectsUsingBlock:^(__kindof UIViewController *_Nonnull obj, NSUInteger idx, BOOL *_Nonnull stop) {
//         if ([obj isKindOfClass:[RCConversationController class]]) {
//             RCConversationController *chatListVC = (RCConversationController *)obj;
//             [chatListVC updateBadgeValueForTabBarItem];
//         }
//     }];
}


- (void)initControllers
{
    RCConversationController *conversationController = [[RCConversationController alloc] init];
    RCMineController *mineController = [[RCMineController alloc] init];
    
    NSArray *subControllers = @[conversationController,mineController];
    
    [subControllers enumerateObjectsUsingBlock:^(UIViewController *controller, NSUInteger idx, BOOL *stop) {
        if([controller isKindOfClass:[RCConversationController class]])//会话
        {
            controller.tabBarItem.title = NSLocalizedString(@"app.conversion", @"Chat");
            controller.tabBarItem.image =
            [[UIImage imageNamed:@"icon_chat"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal];
            controller.tabBarItem.selectedImage =
            [[UIImage imageNamed:@"icon_chat_hover"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal];
        }else if([controller isKindOfClass:[RCMineController class]])
        {
            controller.tabBarItem.title = NSLocalizedString(@"app.mine", @"Chat");
            controller.tabBarItem.image =
            [[UIImage imageNamed:@"icon_me"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal];
            controller.tabBarItem.selectedImage =
            [[UIImage imageNamed:@"icon_me_hover"] imageWithRenderingMode:UIImageRenderingModeAlwaysOriginal];
        }
        [self addChildViewController:controller];
        
    }];
}

@end
