//
//  RCLanguageConfig.h
//  RCIMKitDemo
//
//  Created by zhiheng on 2018/7/10.
//  Copyright © 2018年 com.wc. All rights reserved.
//

#import <Foundation/Foundation.h>


//设置多语言 语言前缀 请参照Project demos 的 info 选项 添加多语言支持的后缀 如Chinese Simple (zh-Hans)的 zh-Hans
NSString *const RCChineseLanuage = @"zh-Hans";
NSString *const RCEnglishLanuage = @"en";


@interface RCLanguageConfig : NSObject

/**
 用户自定义使用的语言
 */
@property (class, nonatomic, strong, nullable,readonly) NSString *userLanguage;

/**
 *设置App内置选择语言 当传nil时，等同于resetSystemLanguage,
 * 外部调用后，需要重置    [UIApplication sharedApplication].delegate.window.rootViewController = [toMain];

 */
+(void)setLanguage:(NSString *)language;

@end
